%% Verschiedene Funktionsaufrufe/Tests zum Erweitern des Schulferienkalenders

% StartTag = datenum('16.07.2017', 'dd.mm.yyyy');
% EndeTag  = datenum('27.10.2018', 'dd.mm.yyyy');
% Tage = StartTag:EndeTag;
% Bundesland = 'BW';
% flag_Ferien_anzeigen = true;
% flag_alle_Ferien_speichern = false;
% force_reload = false;
% flag_Woe_auch_Ferien = true;
% flag_plot = true;
% [idx_Ferien, Ferien_Name, idx_einzelne_Ferien] = Schulferien(Tage, Bundesland, flag_Ferien_anzeigen, flag_alle_Ferien_speichern, force_reload, flag_Woe_auch_Ferien, flag_plot);
% 
% %% Feiertage 
% StartTag = datenum('16.07.2017', 'dd.mm.yyyy');
% EndeTag  = datenum('27.10.2018', 'dd.mm.yyyy');
% Tage = StartTag:EndeTag;
% Bundesland = 'BW';
% flag_Feiertage_anzeigen = true;
% flag_plot = false;
% [idx_Feiertag, Feiertage_Name] = Feiertage(Tage, Bundesland, flag_Feiertage_anzeigen, flag_plot);

%% Matix mit allen Ferientagen:
StartTag = datenum('01.01.2008', 'dd.mm.yyyy');
EndeTag  = datenum('31.12.2008', 'dd.mm.yyyy');
Tage = StartTag:EndeTag;
Bundeslaender = {'BW', 'BY', 'BE', 'BB', 'HB', 'HH', 'HE', 'MV', 'NI', 'NW', 'RP', 'SL', 'SN', 'ST', 'SH', 'TH' };
idx_Ferien  = false(length(Tage), length(Bundeslaender)); % vordimensionieren
Ferien_Name = cell(length(Tage), length(Bundeslaender));  % vordimensionieren
flag_Ferien_anzeigen = false;
flag_alle_Ferien_speichern = false;
force_reload = false;
flag_Woe_auch_Ferien = true;
flag_plot = false;
flag_Feiertage_anzeigen = false;
for cnt_BL = 1 : length(Bundeslaender),
    [idx_Ferien(:, cnt_BL), Ferien_Name(:, cnt_BL)] = Schulferien(Tage, Bundeslaender{cnt_BL}, flag_Ferien_anzeigen, flag_alle_Ferien_speichern, force_reload, flag_Woe_auch_Ferien, flag_plot);
    [idx_Feiertag(:, cnt_BL), Feiertage_Name(:, cnt_BL)] = Feiertage(Tage, Bundeslaender{cnt_BL}, flag_Feiertage_anzeigen, flag_plot);
end

%% Speichern Schulferien
load('Schulferien_saved.mat');

% Umformatieren der Ergebnisse von Schulferien auf Speicherformat
Ferien = strcmp('Herbstferien', Ferien_Name)*1 + strcmp('Osterferien', Ferien_Name)*2 + ...
         strcmp('Pfingstferien', Ferien_Name)*3 + strcmp('Sommerferien', Ferien_Name)*4 + ...
         strcmp('Weihnachten', Ferien_Name)*5 + strcmp('Winterferien', Ferien_Name)*6; 
% Indizierung s. FerienName bei Schulferien_saved

Datum = [Datum; Tage'];
if size (unique(diff(Datum))) > 1
  disp('Achtung, Lcken in Kalender, nicht speichern')
end
BW = [BW; Ferien(:,1)];
BY = [BY; Ferien(:,1)];
BE = [BE; Ferien(:,1)];
BB = [BB; Ferien(:,1)];
HB = [HB; Ferien(:,1)];
HH = [HH; Ferien(:,1)];
HE = [HE; Ferien(:,1)];
MV = [MV; Ferien(:,1)];
NI = [NI; Ferien(:,1)];
NW = [NW; Ferien(:,1)];
RP = [RP; Ferien(:,1)];
SL = [SL; Ferien(:,1)];
SN = [SN; Ferien(:,1)];
ST = [ST; Ferien(:,1)];
SH = [SH; Ferien(:,1)];
TH = [TH; Ferien(:,1)];

% optional, noch als struct zusammengefasst speichern.

% Test, ob die Ferien verschoben sind (wenn nicht -> Fehler):
idx1=(Datum>=StartTag)|(Datum<=EndeTag);
Ferien_verschoben = unique(BW(idx1) == SH(idx1));

%% Test Kalender Deutschland
% % Bundeslaender = {'BW', 'BY', 'BE', 'BB', 'HB', 'HH', 'HE', 'MV', 'NI', 'NW', 'RP', 'SL', 'SN', 'ST', 'SH', 'TH' };
% Tag1 = datenum('01.01.2010', 'dd.mm.yyyy');
% Tag2 = datenum('31.12.2014', 'dd.mm.yyyy');
% Tage = (Tag1:Tag2)';
% Bundeslaender = {'BW', 'BY', 'BE', 'BB', 'HB', 'HH', 'HE', 'MV', 'NI', 'NW', 'RP', 'SL', 'SN', 'ST', 'SH', 'TH' };
% Laender_mit_Ferien = {};
% Alle_Laender = {Bundeslaender{:}, Laender_mit_Ferien{:}};
% Kal = load('Kalender_backup.mat'); 
% flag_gespeicherter_Kalender = Kal.Kalender;
% WetterStation = []; % kein Wetter
% Kalender = cell(length(Alle_Laender), 2); % vordimensionieren
% for cnt_L = 1 : length(Alle_Laender),
%   akt_Land = Alle_Laender{cnt_L};
%   Kalender{cnt_L, 1} = Kalender_erzeugen( Tage, akt_Land, flag_gespeicherter_Kalender, WetterStation );
%   Kalender{cnt_L, 2} = akt_Land;
%   %Erweiterung Schulferien_2015206.mat
%   Ferien = Kalender{cnt_L, 1}.Ferien.Herbstferien + 2* Kalender{cnt_L, 1}.Ferien.Osterferien+ 3*Kalender{cnt_L, 1}.Ferien.Pfingstferien + 4*Kalender{cnt_L, 1}.Ferien.Sommerferien + 5*Kalender{cnt_L, 1}.Ferien.Weihnachtsferien + 6*Kalender{cnt_L, 1}.Ferien.Winterferien;  
%   
% end

