function Kalender = Kalender_erzeugen( Tage, Land, flag_gespeicherter_Kalender, WetterStation, flag_2412_und_3112_auch_Feiertage )
% Gibt einen Kalender zurck
% Tage im Matlab - Zeit als Spaltenvektor n x 1
%
%
%   ---- Eingang Land ----
% Staaten und Bundeslnder mssen in Capital Letter eingehen:
% Fr folgende Staaten existieren die Ferien zwischen 01.01.2008 und 31.12.2013:
% Laender_mit_Ferien = {'DNK', 'POL', 'CZE', 'AUT', 'CHE', 'FRA', 'LUX', 'BEL', 'NLD'};
% Fr alle anderen Staaten werden KEINE Ferien zurckgegen. 
% Bundeslaender = {'BW', 'BY', 'BE', 'BB', 'HB', 'HH', 'HE', 'MV', 'NI', 'NW', 'RP', 'SL', 'SN', 'ST', 'SH', 'TH' };
%
% Landkreise mssen mit Kleinen Buchstaben eingegeben werden.
% Landkreise = {'a' 'aa' 'ab' 'abg' 'abi' 'ac' 'aic' 'ak' 'am' 'an' 'ap' 'as' 'aur' 'aw' 'az' 'a' 'b' 'ba' 'bad' 'bar' 'bb' 'bc' 'bgl' 'bi' 'bir' 'bit' 'bk' 'bl' 'blk' 'bm' 'bn' 'bo' 'bor' 'bot' 'bra' 'brb' 'bs' 'bt' 'bz' 'c' 'cb' 'ce' 'cha' 'clp' 'co' 'coc' 'coe' 'cux' 'cw' 'd' 'da' 'dah' 'dan' 'dau' 'dbr' 'dd' 'de' 'deg' 'del' 'dgf' 'dh' 'dlg' 'dm' 'dn' 'do' 'don' 'du' 'dw' 'e' 'ea' 'ebe' 'ed' 'ee' 'ef' 'ei' 'eic' 'el' 'em' 'emd' 'ems' 'en' 'er' 'erb' 'erh' 'erz' 'es' 'esw' 'eu' 'f' 'fb' 'fd' 'fds' 'ff' 'ffb' 'fg' 'fl' 'fn' 'fo' 'fr' 'frg' 'fri' 'fs' 'ft' 'f' 'g' 'gap' 'ge' 'ger' 'gf' 'gg' 'gi' 'gl' 'gm' 'gp' 'gr' 'grz' 'gs' 'gt' 'gth' 'gz' 'g' 'g' 'h' 'ha' 'hal' 'ham' 'has' 'hb' 'hbn' 'hd' 'hdh' 'he' 'hef' 'hei' 'her' 'hf' 'hg' 'hgw' 'hh' 'hi' 'hl' 'hm' 'hn' 'ho' 'hol' 'hom' 'hp' 'hr' 'hro' 'hs' 'hsk' 'hst' 'hvl' 'hwi' 'hx' 'hz' 'ik' 'in' 'iz' 'j' 'jl' 'k' 'ka' 'kb' 'kc' 'ke' 'keh' 'kf' 'kg' 'kh' 'ki' 'kib' 'kl' 'kle' 'kn' 'ko' 'kr' 'ks' 'kt' 'ku' 'kus' 'kyf' 'kn' 'l' 'la' 'lau' 'lb' 'ld' 'ldk' 'lds' 'ler' 'lev' 'lg' 'li' 'lif' 'lip' 'll' 'lm' 'los' 'lu' 'lwl' 'l' 'm' 'ma' 'mb' 'md' 'me' 'mei' 'mg' 'mh' 'mi' 'mil' 'mk' 'mkk' 'mm' 'mn' 'mol' 'mos' 'mr' 'ms' 'msh' 'msp' 'mst' 'mtk' 'myk' 'mz' 'mzg' 'm' 'mr' 'n' 'nb' 'nd' 'ndh' 'ne' 'nea' 'nes' 'new' 'nf' 'ni' 'nk' 'nm' 'nms' 'noh' 'nom' 'nr' 'nu' 'nvp' 'nw' 'nwm' 'oa' 'oal' 'ob' 'od' 'oe' 'of' 'og' 'oh' 'oha' 'ohv' 'ohz' 'ol' 'opr' 'os' 'osl' 'ovp' 'p' 'pa' 'paf' 'pan' 'pb' 'pch' 'pe' 'pf' 'pi' 'pir' 'pl' 'pm' 'pr' 'ps' 'r' 'ra' 'rd' 're' 'reg' 'rh' 'ro' 'row' 'rp' 'rs' 'rt' 'rv' 'rw' 'rz' 'rd' 'rg' 's' 'sad' 'saw' 'sb' 'sc' 'sdl' 'se' 'sfa' 'sg' 'sha' 'shg' 'shk' 'shl' 'si' 'sig' 'sim' 'sk' 'sl' 'slf' 'slk' 'sls' 'sm' 'sn' 'so' 'sok' 'son' 'sp' 'spn' 'sr' 'st' 'sta' 'std' 'su' 'sw' 'sz' 'sm' 'sw' 'tbb' 'tdo' 'tf' 'tir' 'tr' 'ts' 'tut' 'tl' 't' 'ue' 'uer' 'uh' 'ul' 'um' 'un' 'v' 'vb' 'vec' 'ver' 'vie' 'vs' 'w' 'waf' 'wak' 'wb' 'we' 'wen' 'wes' 'wf' 'whv' 'wi' 'wil' 'wl' 'wm' 'wn' 'wnd' 'wo' 'wob' 'wst' 'wt' 'wtm' 'wug' 'wun' 'ww' 'w' 'z' 'zw';}
%
% flag_gespeicherter_Kalender
% Hier kann auch direkt der Kalender (Kalender.mat) eingehen, damit er nicht jedesmal geladen werden muss (wenn flag_gespeicherter_Kalender == true);
% 
% WetterStation - eine class_Wetter.
% Es werden immer alle Klassen zurckgegeben, auch wenn manche Wetterklassen nie vorkommen
% Gehen mehrere "WetterStation" ein (WetterStation ist Vektor mit class_Wetter) wird die erste verwendet.
%
% % ---------------------------------------------------------------------------------------------------
% % Kalender fr alle Bundeslnder und Europische Lnder:
% % ---------------------------------------------------------------------------------------------------
% Tag1 = datenum('01.01.2008', 'dd.mm.yyyy');
% Tag2 = datenum('31.03.2012', 'dd.mm.yyyy');
% Tage = (Tag1:Tag2)';
% Bundeslaender = {'BW', 'BY', 'BE', 'BB', 'HB', 'HH', 'HE', 'MV', 'NI', 'NW', 'RP', 'SL', 'SN', 'ST', 'SH', 'TH' };
% Laender_mit_Ferien = {'DNK', 'POL', 'CZE', 'AUT', 'CHE', 'FRA', 'LUX', 'BEL', 'NLD'};
% Alle_Laender = {Bundeslaender{:}, Laender_mit_Ferien{:}};
% Kal = load('Kalender.mat'); flag_gespeicherter_Kalender = Kal.Kalender;
% WetterStation = []; % kein Wetter
% Kalender = cell(length(Alle_Laender), 2); % vordimensionieren
% for cnt_L = 1 : length(Alle_Laender),
%   akt_Land = Alle_Laender{cnt_L};
%   Kalender{cnt_L, 1} = Kalender_erzeugen( Tage, akt_Land, flag_gespeicherter_Kalender, WetterStation );
%   Kalender{cnt_L, 2} = akt_Land;
% end
%
% % In eine Excel - Datei schrieben:
% Felder_Exportieren = {'Sommerferien', 'Winterferien', 'Ferienbeginn'};
% Ueberschrift_Spalten = cell(1, length(Alle_Laender) * length(Felder_Exportieren));
% Matrix = false(length(Tage), length(Alle_Laender) * length(Felder_Exportieren)); % vordimensionieren
% for cnt_L = 1 : length(Alle_Laender),
%   for cnt_F = 1 : length(Felder_Exportieren),
%       akt_Feld = Felder_Exportieren{cnt_F};
%       akt_Sp_Matrix = length(Felder_Exportieren)*(cnt_L-1) + cnt_F;
%       Ueberschrift_Spalten{akt_Sp_Matrix} = [Kalender{cnt_L, 2},'_',akt_Feld];
%       if isfield( Kalender{cnt_L, 1}.Ferien, akt_Feld),
%           Matrix(:, akt_Sp_Matrix) = Kalender{cnt_L, 1}.Ferien.(akt_Feld);
%       end
%   end
% end
% Ueberschrift_Zeilen = cellfun(@(x) datestr(x, 'dd.mm.yyyy'), num2cell(Tage), 'UniformOutput', false);
%
% Groesse_Cell = cell(size(Matrix) + [1, 1]); % vordimensionieren
% Groesse_Cell(1,2:end)     = Ueberschrift_Spalten;
% Groesse_Cell(2:end,1)     = Ueberschrift_Zeilen;
% Groesse_Cell(2:end,2:end) = num2cell(Matrix);
%
% Cell2Excel(Groesse_Cell, 'Ferien_Laender')

flag_Ferien_einzeln     = true; % Ferien werden getrennt nach "Winterferien", "Osterferien", "Pfingstferien", usw.
flag_Feiertage_einzeln  = true; % Feiertage werden getrennt nach den einzelnen Feiertagen "Neujahr", "3 Knige", usw. 

if nargin < 1 || isempty(Tage),
    StartTag = datenum('01.01.2008', 'dd.mm.yyyy');
    EndeTag  = datenum('31.12.2013', 'dd.mm.yyyy');
    Tage = (StartTag:EndeTag)'; % als Spaltenvektor
end
if nargin < 2 || isempty(Land), Land = 'BY'; end
if nargin < 3 || isempty(flag_gespeicherter_Kalender), flag_gespeicherter_Kalender = true; end
if nargin < 4 || exist('flag_2412_und_3112_auch_Feiertage','var')==0, flag_2412_und_3112_auch_Feiertage = false; end
% Prfen, ob Land ein Landkreis ist.
if ~any(ismember(Land, [char(65:90),196,214,220])), % Es wird geprft, ob ein Capital Letter im Namen von "Land" ist. [char(65:90),196,214,220] => ABCDEFGHIJKLMNOPQRSTUVWXYZ
    % Wenn es KEINEN Capital Letter wurde ein Landkeis eingegeben.
    Land = Landkreis_in_welchem_Bundesland(Land); % Aus dem Landkreis wird das Bundesland gemacht.
end

% Verwendung egspeicherter Kalender
% Kalender_gespeichert = load('Kalender_backup.mat');
% Datum_Unix = [Kalender_gespeichert.Kalender.Datum_Unix].';
% log_Idx_Anfang = (Datum_Unix==int32(floor(86400 * (Tage(end) - datenum('01-Jan-1970')))));
% log_Idx_Ende = (Datum_Unix==int32(floor(86400 * (Tage(end) - datenum('01-Jan-1970')))));
% if nnz(log_Idx_Anfang) ~=0 && nnz(log_Idx_Ende) ~=0
%     [~,idx_gesTage_Kal_gespeichertAnfang] = max(log_Idx_Anfang);
%     [~,idx_gesTage_Kal_gespeichertEnde] = max(log_Idx_Ende);
%     Kalender_gespeichert = Kalender_gespeichert.Kalender(idx_gesTage_Kal_gespeichertAnfang:idx_gesTage_Kal_gespeichertEnde,:);
% else
%     Kalender_gespeichert = [];
% end


Kalender.Datum = Tage;


flag_plot = false;

%% Schulferien:
flag_Ferien_anzeigen = true;
flag_alle_Ferien_speichern = false;
force_reload = false;
flag_Woe_auch_Ferien = true;

[idx_Ferien, Ferien_Name, idx_einzelne_Ferien] = Schulferien(Tage, Land, flag_Ferien_anzeigen, flag_alle_Ferien_speichern, force_reload, flag_Woe_auch_Ferien, flag_plot);
idx_member = true(size(idx_Ferien)); % Hier mssen keine Zeiten ausgefiltert werden.

Kalender.Ferien.Ferien = idx_Ferien(idx_member);
Kalender.Ferien.Ferien_Name = Ferien_Name(idx_member);

if flag_Ferien_einzeln,
    Felder_Ferien = fieldnames(idx_einzelne_Ferien);
    for cnt_FF = 1 : length(Felder_Ferien),
        akt_Feld = Felder_Ferien{cnt_FF};
        Kalender.Ferien.(akt_Feld) = idx_einzelne_Ferien.(akt_Feld)(idx_member);
    end
end


%% Feiertage:
flag_Feiertage_anzeigen = false;
% Es werden immer die Feiertage von Bayern verwendet.
% Dabei ist nur der Reformationstag ein Feiertag, der in anderen BL vorkommen kann und in Bayern nicht.
% Entscheidend fr diese Wahl ist, dass in einer Prognose auch nicht die verschiedenen Feiertage in den BL bercksichtigt werden sollen => keep it simple.
flag_immer_die_Feiertage_von_Bayern = true; 
if flag_immer_die_Feiertage_von_Bayern,
    [idx_Feiertag, Feiertage_Name, idx_einzelne_Feiertage] = Feiertage(Tage, 'BY', flag_Feiertage_anzeigen, flag_plot, flag_2412_und_3112_auch_Feiertage);
else
    [idx_Feiertag, Feiertage_Name, idx_einzelne_Feiertage] = Feiertage(Tage, Land, flag_Feiertage_anzeigen, flag_plot, flag_2412_und_3112_auch_Feiertage);
end

Kalender.Feiertage.Feiertag       = idx_Feiertag;
Kalender.Feiertage.Feiertage_Name = Feiertage_Name;

if flag_Feiertage_einzeln,
    Felder_Feiertage = fieldnames(idx_einzelne_Feiertage);
    for cnt_FF = 1 : length(Felder_Feiertage),
        akt_Feld = Felder_Feiertage{cnt_FF};
        Kalender.Feiertage.(akt_Feld) = idx_einzelne_Feiertage.(akt_Feld);
    end
end

% Ausnahme Reformationstag 2017
idx_Ref17 = (Tage == 736999);
if nnz(idx_Ref17) > 0 % Tag innerhalb dem Zeitraum
    Kalender.Feiertage.Feiertag(idx_Ref17) = 1;
    Kalender.Feiertage.Feiertage_Name(idx_Ref17) = 'Reformationstag';
end

%% Wochentag:
Wochentag = weekday(Kalender.Datum);
Wochentage = {'Sonntag', 'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag', 'Freitag', 'Samstag'};
for cnt = 1 : 7,
    Kalender.Wochentag.(Wochentage{cnt}) = Wochentag == cnt;
end

% Werktage sind Mo,Di, ... Fr und KEIN Feiertag
idx_Werktag = ismember(Wochentag, 2:6) & ~Kalender.Feiertage.Feiertag; % 1: Sonntag, 7: Samstag

%% Brueckentag
% d.h. Vorgnger ist kein Werktag, der Tag selbst ist ein Werktag und der Nachfolger ist kein Werktag
% (der erste/letzte Tag im Kalender ist kein Brckentag)
if length(Wochentag) == 1,
    Kalender.Sonstige_Tage.Brueckentag = false;
elseif length(Wochentag) == 2,
    Kalender.Sonstige_Tage.Brueckentag = [false; false];
else
    Kalender.Sonstige_Tage.Brueckentag = [false; ~idx_Werktag(1:end-2) & idx_Werktag(2:end-1) & ~idx_Werktag(3:end); false];
end

%% WerktagVorFeiertag
% d.h. Nachfolger ist ein Feiertag und der Tag selbst ein Werktag (der kein Feiertag sein kann und automatisch Mo-Fr ist)
% (der letzte Tag im Kalender ist kein WerktagVorFeiertag)
if length(Wochentag) == 1,
    Kalender.Sonstige_Tage.WerktagVorFeiertag = false;
else
    Kalender.Sonstige_Tage.WerktagVorFeiertag = [Kalender.Feiertage.Feiertag(2:end) & idx_Werktag(1:end-1); false];
end


%% Ferienbeginn (letzter Tag vor den Ferien + erste beiden Ferientage)
Kalender.Ferien.erster_Ferientag = [false; diff(Kalender.Ferien.Ferien) == 1];
Kalender.Ferien.letzer_Tage_vor_Ferien = [Kalender.Ferien.erster_Ferientag(2:end); false]; % Ein Tag frher
idx_zweiter_Ferientag = [false; Kalender.Ferien.erster_Ferientag(1:end - 1)]; % Ein Tag spter
Kalender.Ferien.Ferienbeginn = Kalender.Ferien.erster_Ferientag | Kalender.Ferien.letzer_Tage_vor_Ferien | idx_zweiter_Ferientag;

%% Untersuchung Ferienende
Kalender.Ferien.letzter_Ferientag = [diff(Kalender.Ferien.Ferien) == -1; false];

%% Jahreszeit:
wie_Jahreszeit = 1; 
Feld_Jahreszeit = 'Jahreszeit';
Zusatz_Bezeichnung = '';
[Jahreszeiten_num, Jahreszeiten_Bezeichnung] = Jahreszeiten( Tage, wie_Jahreszeit, Zusatz_Bezeichnung );

for cnt_JZ = 1 : length(Jahreszeiten_Bezeichnung),
    akt_Jahreszeit = Jahreszeiten_Bezeichnung{cnt_JZ};
    akt_Jahreszeit = strrep(akt_Jahreszeit, '', 'ue');

    Kalender.(Feld_Jahreszeit).(akt_Jahreszeit) = Jahreszeiten_num == cnt_JZ;
end

%% Jahreszeit kalendarisch:
wie_Jahreszeit = 2; 
Feld_Jahreszeit = 'Jahreszeit_kalendarisch';
Zusatz_Bezeichnung = '_kalendarisch';
[Jahreszeiten_num, Jahreszeiten_Bezeichnung] = Jahreszeiten( Tage, wie_Jahreszeit, Zusatz_Bezeichnung );

for cnt_JZ = 1 : length(Jahreszeiten_Bezeichnung),
    akt_Jahreszeit = Jahreszeiten_Bezeichnung{cnt_JZ};
    akt_Jahreszeit = strrep(akt_Jahreszeit, '', 'ue');

    Kalender.(Feld_Jahreszeit).(akt_Jahreszeit) = Jahreszeiten_num == cnt_JZ;
end

%% Jahreszeit kalendarisch:
wie_Jahreszeit = 3; 
Feld_Jahreszeit = 'Jahreszeit_extra';
Zusatz_Bezeichnung = '_extra';
[Jahreszeiten_num, Jahreszeiten_Bezeichnung] = Jahreszeiten( Tage, wie_Jahreszeit, Zusatz_Bezeichnung );

for cnt_JZ = 1 : length(Jahreszeiten_Bezeichnung),
    akt_Jahreszeit = Jahreszeiten_Bezeichnung{cnt_JZ};
    akt_Jahreszeit = strrep(akt_Jahreszeit, '', 'ue');

    Kalender.(Feld_Jahreszeit).(akt_Jahreszeit) = Jahreszeiten_num == cnt_JZ;
end


%% Oktoberfest:
Tage_Oktoberfest = {
    '20.09.2008', '05.10.2008';
    '19.09.2009', '04.10.2009';
    '18.09.2010', '04.10.2010';
    '17.09.2011', '03.10.2011';
    '22.09.2012', '07.10.2012';
    '21.09.2013', '06.10.2013';
    };
Tage_Oktoberfest_num = cellfun(@(x) datenum(x, 'dd.mm.yyyy'), Tage_Oktoberfest);
flag_jeder_Werte_einmal = true;
flag_letzte_Werte_nicht = false;
Alle_Tage_Oktoberfest = Alle_Werte_dazwischen(Tage_Oktoberfest_num, flag_jeder_Werte_einmal, flag_letzte_Werte_nicht);

Kalender.Sonstige_Tage.Oktoberfest = ismember(Tage, Alle_Tage_Oktoberfest);
    

%% Wetter:
if nargin < 4 || isempty(WetterStation)
    % Keine WetterStation eingegeben.
elseif isa(WetterStation, 'class_Wetter'),
    % Es werden immer alle Klassen zurckgegeben, auch wenn manche Wetterklassen nie vorkommen:
    % Wetterklassen auslesen:
    %
    % welche_Wetterklasse
    % 0: Wetterklasse_differenziert
    % 1: Wetterklasse_UniS
    % 2: Wetterklasse_grob
    welche_Wetterklasse = 1;
    [Wetter_num, Wetter] = WetterStation.Wetterklassenmatrix(welche_Wetterklasse);
    Bez_WetterKlassen = WetterStation.Bezeichnung_WetterKlassen(welche_Wetterklasse);
    Wetter = Wetter{1};
    
    
    %% Wetterklasse:
    [~, idx_member] = ismember(Tage, round(unix_Zeit([Wetter{:,1}],2)));
    if any(idx_member == 0),
        % Es gibt "Tage" fr die kein Wetter verfgbar ist.
        % Diesen Tage wird die Wetterklasse "nicht zugeordnet" zugeordnet.
        Kalender.Wetter.Wetterklasse_Name = cell(length(idx_member), 1); % vordimensionieren
        Wetter_num_hier                   = zeros(length(idx_member), 1); % vordimensionieren
        
        idx_kein_Wetter_vorhanden = idx_member == 0;
        [Kalender.Wetter.Wetterklasse_Name{idx_kein_Wetter_vorhanden}] = deal('nicht zugeordnet');
        Wetter_num_hier(idx_kein_Wetter_vorhanden) = -1;
        
        zeilen_Wetter_vorhanden = idx_member(~idx_kein_Wetter_vorhanden);
        Kalender.Wetter.Wetterklasse_Name(~idx_kein_Wetter_vorhanden) = Wetter(zeilen_Wetter_vorhanden,2);
        Wetter_num_hier(~idx_kein_Wetter_vorhanden) = Wetter_num{1}(zeilen_Wetter_vorhanden, 2);
    else
        Kalender.Wetter.Wetterklasse_Name = Wetter(idx_member,2);
        Wetter_num_hier = Wetter_num{1}(idx_member, 2);
    end
    

    for cnt_WK = 1 : size(Bez_WetterKlassen,1),
        akt_Bez_WK = Bez_WetterKlassen{cnt_WK,2};
        idx_akt_Wetter = Wetter_num_hier == Bez_WetterKlassen{cnt_WK,1};
        % Name so ndern, damit man es als Fieldname verwenden kann:
        akt_Bez_WK = strrep(akt_Bez_WK, ' ', '_');
        akt_Bez_WK = strrep(akt_Bez_WK, '/', '_');
        Kalender.Wetter.(['idx_',akt_Bez_WK]) = idx_akt_Wetter;
    end
    
else
    warning('Der Eingang "WetterStation" ist keine class_Wetter')
end

% Alle Felder als Spaltenvektoren:
flag_als_Zeilenvektor = false;
Kalender = Struct_Felder_als_Spaltenvektoren(Kalender, flag_als_Zeilenvektor);




end % function























